#include<dos.h>
#include<iostream.h>
#include<conio.h>
#include<stdlib.h>
#include<mem.h>
#include<math.h>

unsigned char * vga = (unsigned char*)MK_FP(0xa000,0);

void setMCGA(){
  _AX=0x13;
  geninterrupt(0x0010);

}

void setText(){
  _AX=0x0003;
  geninterrupt(0x0010);
}

void memPutPixel(int x,int y,unsigned char col){
  memset(vga + x + y*320,col,1);
}

int sgn (long a) {
  if (a > 0) return +1;
  else if (a < 0) return -1;
  else return 0;
}


void intPutPixel(int x,int y,unsigned char col){
  _AH=0x00C;
  _AL=col;
  _CX=x;
  _DX=y;
  _BX=0x001;
  geninterrupt(0x0010);
}

void _gClearScr(unsigned char col){
  memset(vga,col,0xffff);
}

void _gCircle1(int X, int Y, int rad, int col) {
  float deg = 0;
  do {
    X = (rad * cos(deg));
    Y = (rad * sin(deg));
    memPutPixel (X+160, Y+100, col);
    deg += 0.005;
  }
  while (deg <= 6.4);
}

void _gPlotPoints1(int xc, int yc, int x, int y, unsigned char col){
  memPutPixel(xc + x,yc + y, col);
  memPutPixel(xc + x,yc - y, col);
  memPutPixel(xc - x,yc + y, col);
  memPutPixel(xc - x,yc - y, col);
  memPutPixel(xc + y,yc + x, col);
  memPutPixel(xc + y,yc - x, col);
  memPutPixel(xc - y,yc + x, col);
  memPutPixel(xc - y,yc - x, col);
}

void _gMidPtCircle(int xc, int yc,int r, unsigned char col){
  int x=0,y=r,p;
  _gPlotPoints1(xc,yc,x,y,col);
  p=1-r;
  while(x<y){
    if(p>=0)
      y--;
    x++;
    if(p<0)
      p+=2*x+1;
    else
      p+=2*(x-y)+1;
    _gPlotPoints1(xc,yc,x,y,col);
  }
}

float _gGetSlope(int xa, int ya, int xb, int yb){
  if (xa!=xb)
    return (float)(yb-ya)/(xb-xa);
  else
    return 32000;
}

void _gLineBres(int xa, int ya, int xb, int yb, unsigned col){
  int dx,dy,x,y,p;
  float slope=_gGetSlope(xa,ya,xb,yb);
  if ( fabs(slope)<=1) {
    if(slope>0){
      int xEnd;
      dx=abs(xa-xb);
      dy=abs(ya-yb);
      p= 2* dy-dx;
      if(xa>xb){
        x=xb;
        y=yb;
        xEnd=xa;
      }
      else{
        x=xa;
        y=ya;
	xEnd=xb;
      }
      memPutPixel(x,y,col);
      while(x<xEnd){
        x++;
        if(p<0)
          p+=2*dy;
        else{
	  p+=2*(dy-dx);
          y++;
        }
        memPutPixel(x,y,col);
      }
    }
    else{
      int xEnd;
      dx=abs(xa-xb);
      dy=abs(ya-yb);
      p= 2* dy-dx;
      if(xa>xb){
	x=xb;
        y=yb;
        xEnd=xa;
      }
      else{
        x=xa;
        y=ya;
        xEnd=xb;
      }
      memPutPixel(x,y,col);
      while(x<xEnd){
        x++;
        if(p<0)
          p+=2*dy;
        else{
          p+=2*(dy-dx);
          y--;
        }
        memPutPixel(x,y,col);
      }
    }
  }
  else{
    if(slope>0){
      int yEnd;
      dx=abs(xa-xb);
      dy=abs(ya-yb);
      p= 2* dx-dy;
      if(ya>yb){
        x=xb;
        y=yb;
        yEnd=ya;
      }
      else{
        x=xa;
        y=ya;
        yEnd=yb;
      }
      memPutPixel(x,y,col);
      while(y<yEnd){
	y++;
        if(p<0)
          p+=2*dx;
        else{
          p+=2*(dx-dy);
          x++;
        }
        memPutPixel(x,y,col);
      }
    }
    else{
      int yEnd;
      dx=abs(xa-xb);
      dy=abs(ya-yb);
      p= 2* dx-dy;
      if(ya>yb){
        x=xb;
        y=yb;
        yEnd=ya;
      }
      else{
        x=xa;
        y=ya;
        yEnd=yb;
      }
      memPutPixel(x,y,col);
      while(y<yEnd){
        y++;
	if(p<0)
          p+=2*dx;
        else{
          p+=2*(dx-dy);
          x--;
        }
        memPutPixel(x,y,col);
      }
    }
  }
}

void gLine1(int a, int b, int c, int d, int col) {
  long u,s,v,d1x,d1y,d2x,d2y,m,n;
  int  i;
  u   = c-a;      
  v   = d-b;
  d1x = sgn(u);   
  d1y = sgn(v);   
  d2x = sgn(u);   
  d2y = 0;
  m   = abs(u);
  n   = abs(v);   
  if (m<=n) {     
    d2x = 0;
    d2y = sgn(v); 
    m   = abs(v); 
    n   = abs(u); 
  }
  s = (int)(m / 2);
  for (i=0;i<int (m);i++) { 
                             
    memPutPixel(a,b,col);
    s += n;                  
    if (s >= m) {            
      s -= m;
      a += d1x;
      b += d1y;
    }
    else {
      a += d2x;
      b += d2y;
    }
  }
}

void WaitRetrace() {
  _DX = 0x03DA;
  l1: asm {
    in  al,dx;
    and al,0x08;
    jnz l1;
  }
  l2: asm {
    in  al,dx;
    and al,0x08;
    jz  l2;
  }
}

/*void surfaceV1(int x1,int y1, int x2, int y2, int h1,int h2, int col){
  for(int a=0;(y2-a > 0);a++)
    _gLineBres(x1,y1-(h1*a/h2),x2,(y2-a),col+(a*15/h2));
  if(a<h2){
    float slope= _gGetSlope(x1,y1,x2,y2);
    for(;(a<h1);a++)
      _gLineBres(x1,y1-(h1*a/h2),(y1-h1*a/h2)/(slope+((float (h1/h2)-1)*a/(x2-x1))),0,50);//col+a*15/h2);
  }
} */

void initMouse(){
  _AX=0;
  geninterrupt(0x33);
}

void showMousePtr(){
  _AX=1;
  geninterrupt(0x0033);
}

void getMousePos(int &b,int &x, int &y){
  _AX=0x003;
  geninterrupt(0x0033);
  b=_BX;
  x=_CX;
  y=_DX;
}

void setMousePtr(int x, int y){
  _AX=4;
  _CX=x;
  _DX=y;
  geninterrupt(0x0033);
}

void restrictMousePtr(int x1,int y1, int x2, int y2){
  _AX=7;
  _CX=x1,
  _DX=x2;
  geninterrupt(0x0033);
  _AX=8;
  _CX=y1;
  _DX=y2;
  geninterrupt(0x0033);
}

unsigned char pall[256][3], pall2[2565][3];

void _gGrabPal(unsigned char col,unsigned char &R, unsigned char &G, unsigned char &B){

  outp(0x03C9,col);
  R = inp(0x03C9);
  G = inp(0x03C9);
  B = inp(0x03C9);
}

void GrabPallette() {

  for(int loop1=0;loop1<256;loop1++)
    _gGrabPal(loop1,pall2[loop1][0],pall2[loop1][1],pall2[loop1][2]);

}

void _gPal(unsigned char col, unsigned char R, unsigned char G,unsigned char B) {

  outp (0x03C8,col); 
  outp (0x03C9,R);
  outp (0x03C9,G);
  outp (0x03C9,B);

}

void _gFadeUp(){
  unsigned char t,t1;
  for(int i1=1;i1<9;i1++){
    _gGrabPal(i1,t1,t,t1);
    WaitRetrace();
    if(t< 63/i1){
      delay(200*i1);
      t++;
    }
    _gPal(i1,0,t,0);
  }
}

void _gFadeDown(){
  unsigned char t,t1;
    for(int i2=1;i2<9;i2++){
      WaitRetrace();
      _gGrabPal(i2,t1,t,t1);
      if(t>15/i2){
        delay(1000/i2);
        t-=2;
      }
      _gPal(i2,0,t,0);
  }
}

void PalPlay_R() {
  unsigned char tmp[3];
  memmove(tmp,pall[200],3);
  memmove(pall[2],pall[1],199*3);
  memmove(pall[1],tmp,3);
  WaitRetrace();
  for (int i=0;i<256;i++)
   _gPal(i,pall[i][0], pall[i][1], pall[i][2]);
}

void PalPlay_G() {
  unsigned char tmp[3];
  memmove(tmp,pall[200],3);
  memmove(pall[2],pall[1],199*3);
  memmove(pall[1],tmp,3);
  WaitRetrace();
  for (int i=0;i<256;i++)
   _gPal(i,pall[i][1], pall[i][0], pall[i][2]);
}

void PalPlay_B() {
  unsigned char tmp[3];
  memmove(tmp,pall[200],3);
  memmove(pall[2],pall[1],199*3);
  memmove(pall[1],tmp,3);
  WaitRetrace();
  for (int i=0;i<256;i++)
   _gPal(i,pall[i][1], pall[i][2], pall[i][0]);
}

void PalPlay_A() {
  unsigned char tmp[3];
  memmove(tmp,pall[200],3);
  memmove(pall[2],pall[1],199*3);
  memmove(pall[1],tmp,3);
  WaitRetrace();
  for (int i=0;i<256;i++)
   _gPal(i,pall[i][0], pall[i][0], pall[i][0]);
}


void Blackout() {
  WaitRetrace();
  for (int loop1=0;loop1<256;loop1++)
   _gPal (loop1,0,0,0);
}

void RestorePallette() {
  WaitRetrace();
  for(int loop1=0; loop1<255; loop1++)
    _gPal(loop1,pall2[loop1][0],pall2[loop1][1],pall2[loop1][2]);
}

void SetUpScreen() {
  memset(pall,0,sizeof(pall));
  for (int loop = 0; loop < 201;loop++)
    pall[loop][0] = loop % 64;
  for (loop = 0; loop < 321; loop++) {
    _gLineBres(319,199,320-loop,0,(loop % 199) + 1);
    _gLineBres(0,0,loop,199,(loop % 199) + 1);
    PalPlay_R();
  }
  for (loop = 0; loop < 321; loop++) {
    _gLineBres(319,199,320-loop,0,(loop % 199) + 1);
    _gLineBres(0,0,loop,199,(loop % 199) + 1);
    PalPlay_G();
  }
  for (loop = 0; loop < 321; loop++) {
    _gLineBres(319,199,320-loop,0,(loop % 199) + 1);
    _gLineBres(0,0,loop,199,(loop % 199) + 1);
    PalPlay_B();
  }
  for (loop = 0; loop < 321; loop++) {
    _gLineBres(319,199,320-loop,0,(loop % 199) + 1);
    _gLineBres(0,0,loop,199,(loop % 199) + 1);
    PalPlay_A();
  }
  _gClearScr(0);
}

void _gSetG_Pal(unsigned char a1,unsigned int a2){
  for(unsigned int i = 0; i<a2; i++)
    _gPal(a1+ i,0,63 - i*63/a2,0);
}

void _gAntiAliasedLineV_G(int x1,int y1, int x2, int y2,int h1,int h2 ,unsigned int a1, unsigned int a2){
  if (h1>h2){
    for(unsigned int i1=0;i1 < h1; i1++){
      _gLineBres(x1,y1-i1,x2,y2-((h2*i1)/h1),a1 + i1*a2/h1);
      _gLineBres(x1,y1+i1,x2,y2+((h2*i1)/h1),a1 + i1*a2/h1);
    }
  }
  else  {
    for(int i1=0;i1 < h2; i1++){
      _gLineBres(x1,y1-(i1*h1)/h2,x2,y2-i1,a1 + i1*a2/h2);
      _gLineBres(x1,y1+(i1*h1)/h2,x2,y2+i1,a1 + i1*a2/h2);
    }
  }
}

void _gAntiAliasedLineH_G(int x1,int y1, int x2, int y2,int h1,int h2,unsigned int a1, unsigned int a2){
  if (h1>h2){
    for(unsigned int i1=0;i1 < h1; i1++){  
      _gLineBres(x1-i1,y1,x2-((h2*i1)/h1),y2,a1 + i1*a2/h1);
      _gLineBres(x1+i1,y1,x2+((h2*i1)/h1),y2,a1 + i1*a2/h1);
    }
  }
  else  {
    for(int i1=0;i1 < h2; i1++){
      _gLineBres(x1-(i1*h1)/h2,y1,x2-i1,y2,a1 + i1*a2/h2);
      _gLineBres(x1+(i1*h1)/h2,y1,x2+i1,y2,a1 + i1*a2/h2);
    }
  }
}

void _gHiddenScrSetup(){
  _gClearScr(8);
  for(int i = 1 ; i < 8 ; i++)
    _gPal(i , 0 ,31/i ,0);
  _gAntiAliasedLineH_G(38,50,38,90,8,8,1,8);
  _gAntiAliasedLineV_G(38,50,59,50,8,8,1,8);
  _gAntiAliasedLineV_G(38,70,59,70,8,8,1,8);
  _gAntiAliasedLineV_G(38,90,59,90,8,8,1,8);

  _gAntiAliasedLineH_G(91,50,69,90,8,8,1,8);
  _gAntiAliasedLineH_G(69,50,91,90,8,8,1,8);

  _gAntiAliasedLineH_G(112,50,101,90,8,8,1,8);
  _gAntiAliasedLineH_G(112,50,123,90,8,8,1,8);

  _gAntiAliasedLineH_G(132,50,144,70,8,8,1,8);
  _gAntiAliasedLineH_G(144,70,155,50,8,8,1,8);
  _gAntiAliasedLineH_G(132,50,132,90,8,8,1,8);
  _gAntiAliasedLineH_G(155,50,155,90,8,8,1,8);

  _gAntiAliasedLineV_G(179,58,187,62,8,8,1,8);
  _gAntiAliasedLineV_G(179,70,187,66,8,8,1,8);
  _gAntiAliasedLineV_G(165,58,179,58,8,8,1,8);
  _gAntiAliasedLineV_G(165,70,179,70,8,8,1,8);
  _gAntiAliasedLineH_G(187,62,187,66,8,8,1,8);
  _gAntiAliasedLineH_G(165,50,165,90,8,8,1,8);


  _gAntiAliasedLineH_G(197,50,197,90,8,8,1,8);
  _gAntiAliasedLineV_G(197,82,219,82,8,8,1,8);

  _gAntiAliasedLineH_G(229,50,229,90,8,8,1,8);
  _gAntiAliasedLineV_G(229,58,251,58,8,8,1,8);
  _gAntiAliasedLineV_G(229,70,251,70,8,8,1,8);
  _gAntiAliasedLineV_G(229,82,251,82,8,8,1,8);

  _gAntiAliasedLineH_G(261,64,270,50,8,8,1,8);
  _gAntiAliasedLineH_G(261,64,270,70,8,8,1,8);
  _gAntiAliasedLineH_G(283,76,274,70,8,8,1,8);
  _gAntiAliasedLineH_G(283,76,274,90,8,8,1,8);
  _gAntiAliasedLineV_G(270,54,283,54,8,8,1,8);
  _gAntiAliasedLineV_G(270,70,274,70,8,8,1,8);
  _gAntiAliasedLineV_G(256,86,274,86,8,8,1,8);
}

int _g3rdSide(double x, double y){
  return(sqrt( x* x +y * y));
}

